import org.eclipse.swt.SWT;
import org.eclipse.swt.events.*;
import org.eclipse.swt.graphics.*;
import org.eclipse.swt.layout.*;
import org.eclipse.swt.widgets.*;
import java.net.InetAddress;
import snmp.*;
import sun.net.TelnetOutputStream;

public class MonitorEder {
	// The width (and height) of the image

	int A = 200, B = 200;
	// The timer interval in milliseconds
	private static final int TIMER_INTERVAL = 1000;
	// We draw everything on this canvas
	private Canvas canvas;
	
	String community = "public";
	int version = 0; // SNMPv1
	int bekleme = 3000; // milisaniye
	SNMPv1CommunicationInterface iletisimArayuzu = null;
	InetAddress hostAddress = null;
	SNMPVarBindList snmpIAL = null; // IAD: iletisim arayuzu listesi
	SNMPSequence snmpCifti = null;
	SNMPObject snmpDegeri = null;
	int dizi[] = new int[9];
	
	TelnetOutputStream tout;
	
	
	byte[] buffer = new byte[1024];
	
	int numOfLines = 11, width = 705, height = 550;
	
	int elemanSayisi = 0, basEleman = 0, maksimumEleman = 200, denemeAraligi = 30;
	int maksimum, sayac;
	int bwGiris[] = new int[maksimumEleman];
	int bwCikis[] = new int[maksimumEleman];
	int bwOrtalama[] = new int[maksimumEleman];
	//                      ALINAN sekizli sayisi  -  VERILEN sekizli sayisi  -  arayuzun HIZI
	String[] adresler = { "1.3.6.1.2.1.2.2.1.10.3", "1.3.6.1.2.1.2.2.1.16.3", "1.3.6.1.2.1.2.2.1.5.3" };

	public MonitorEder(TelnetOutputStream tout_in){
		try {
			hostAddress 	= 	InetAddress.getByName("1.1.1.200");
			iletisimArayuzu = 	new SNMPv1CommunicationInterface(version, hostAddress, community);
			this.tout = tout_in;
		} catch (Exception e) {
			System.out.println("ERROR: initialize error in constructor" + e);
		}
	}
	
	public void run() {
		final Display display = new Display();
		Shell shell = new Shell(display);
		shell.setText("Monitr Eder");
		createContents(shell);
		shell.setSize(width, height);
		shell.open();

		// Set up the timer for the animation
		Runnable runnable = new Runnable() {
			public void run() {
				animate();
				display.timerExec(TIMER_INTERVAL, this);
				TelnetShowKullan();
			}
		};

		// Launch the timer
		display.timerExec(TIMER_INTERVAL, runnable);

		while (!shell.isDisposed()) {
			if (!display.readAndDispatch()) {
				display.sleep();
			}
		}

		// Kill the timer
		display.timerExec(-1, runnable);
		display.dispose();
	}
	
	private void TelnetShowKullan(){
		try {
			int avail = System.in.available();
			if (avail > 0) {
				avail = System.in.read(buffer, 0, 1024);
				tout.setStickyCRLF(true);
				tout.write(buffer, 0, avail);
				tout.flush();
			}
		} catch (Exception e) {
			System.out.println("HATA : TelnetShowKullan");
		}
	}

	private void createContents(final Shell shell) {
		shell.setLayout(new FillLayout());

		// Create the canvas for drawing
		canvas = new Canvas(shell, SWT.NO_BACKGROUND);
		canvas.addPaintListener(new PaintListener() {
			public void paintControl(PaintEvent event) {
				// Create the image to fill the canvas
				Image image = new Image(shell.getDisplay(), canvas.getBounds());

				// Set up the offscreen gc
				GC gcImage = new GC(image);

				// Draw the background
				gcImage.setBackground(event.gc.getBackground());
				gcImage.fillRectangle(image.getBounds());

				// Set the color of the lines
				int left = 50, right = 60, top = 40, bottom = 80;
				int aralikX = (width - left - right) / numOfLines;
				int aralikY = (height - top - bottom) / numOfLines;
				
				gcImage.setBackground(shell.getDisplay().getSystemColor(SWT.COLOR_BLACK));
				gcImage.fillRectangle(left, top, width-left-right, aralikY*3);
				gcImage.fillRectangle(left, top+aralikY*4, width-left-right, aralikY*3);
				gcImage.fillRectangle(left, top+aralikY*8, width-left-right, aralikY*3);
				
				gcImage.setForeground(shell.getDisplay().getSystemColor(SWT.COLOR_DARK_GRAY));
				// Draw the lines
				for(int i=0; i<numOfLines+1; i++){
					gcImage.drawLine(left + i*aralikX, top, left + i*aralikX, top + 3*aralikY);
					gcImage.drawLine(left + i*aralikX, top + 4*aralikY, left + i*aralikX, top + 7*aralikY);
					gcImage.drawLine(left + i*aralikX, top + 8*aralikY, left + i*aralikX, top + 11*aralikY);
					gcImage.drawLine(left, top + i*aralikY, width - right-1, top + i*aralikY);
				}
				
				gcImage.setForeground(shell.getDisplay().getSystemColor(SWT.COLOR_RED));
				gcImage.drawString("indirilen", width-right-50, top+8*aralikY+5);
				int j = 0, simdiki, onceki, yukseklik = maksimum / (height-top-bottom);
				gcImage.setClipping(left, top+8*aralikY, width-left-right, 3*aralikY+1);
				if(yukseklik == 0) yukseklik = 1;
				for(int i = basEleman; i != basEleman + 1 && j++ < elemanSayisi-1; i = (i + maksimumEleman -1)%maksimumEleman){
					simdiki = height - bwGiris[i] / yukseklik - bottom;
					onceki = height - bwGiris[(i + maksimumEleman -1)%maksimumEleman] / yukseklik - bottom;
					gcImage.drawLine(left+j*3,simdiki,left+(j+1)*3,onceki);
				}
				gcImage.setClipping(left, top+4*aralikY, width-left-right, 3*aralikY+1);
				gcImage.setForeground(shell.getDisplay().getSystemColor(SWT.COLOR_YELLOW));
				gcImage.drawString("yklenen", width-right-50, top+4*aralikY+5);
				j = 0;
				for(int i = basEleman; i != basEleman + 1 && j++ < elemanSayisi-1; i = (i + maksimumEleman -1)%maksimumEleman){
					simdiki = height - bwCikis[i] / yukseklik - bottom - 4*aralikY;
					onceki = height - bwCikis[(i + maksimumEleman -1)%maksimumEleman] / yukseklik - bottom - 4*aralikY;
					gcImage.drawLine(left+j*3,simdiki,left+(j+1)*3,onceki);
				}
				gcImage.setClipping(left, top, width-left-right, 3*aralikY+1);
				gcImage.setForeground(shell.getDisplay().getSystemColor(SWT.COLOR_GREEN));
				gcImage.drawString("ortalama", width-right-50, top+5);
				j = 0;
				for(int i = basEleman; i != basEleman + 1 && j++ < elemanSayisi-1; i = (i + maksimumEleman -1)%maksimumEleman){
					simdiki = height - bwOrtalama[i] / yukseklik - bottom - 8*aralikY;
					onceki = height - bwOrtalama[(i + maksimumEleman -1)%maksimumEleman] / yukseklik - bottom - 8*aralikY;
					gcImage.drawLine(left+j*3,simdiki,left+(j+1)*3,onceki);
				}
				gcImage.setClipping(image.getBounds());
				gcImage.setForeground(shell.getDisplay().getSystemColor(SWT.COLOR_BLACK));
				gcImage.setBackground(event.gc.getBackground());
				maksimum /= 3;
				if(maksimum < 1024){
					gcImage.drawString(maksimum + " b", left-40, top-5);
					gcImage.drawString(maksimum + " b", left-40, top-5+4*aralikY);
					gcImage.drawString(maksimum + " b", left-40, top-5+8*aralikY);
				}else if(maksimum < 1024*1024){
					gcImage.drawString(maksimum/1024 + " kb", left-40, top-5);
					gcImage.drawString(maksimum/1024 + " kb", left-40, top-5+4*aralikY);
					gcImage.drawString(maksimum/1024 + " kb", left-40, top-5+8*aralikY);
				}else{
					gcImage.drawString(maksimum/(1024*1024) + " mb", left-40, top-5);
					gcImage.drawString(maksimum/(1024*1024) + " mb", left-40, top-5+4*aralikY);
					gcImage.drawString(maksimum/(1024*1024) + " mb", left-40, top-5+8*aralikY);
				}
				// Draw the offscreen buffer to the screen
				event.gc.drawImage(image, 0, 0);

				// Clean up
				image.dispose();
				gcImage.dispose();
			}
		});
	}

	public void animate() {

		try {
			if (dizi[3] + dizi[4] > 0) {
				dizi[6] = 1000 * (dizi[0] - dizi[3]) / bekleme;
				dizi[7] = 1000 * (dizi[1] - dizi[4]) / bekleme;
				dizi[8] = (dizi[7] + dizi[6]) / 2;
				
				if(elemanSayisi < maksimumEleman)
					++elemanSayisi;
				basEleman = (basEleman + 1)%maksimumEleman;
				maksimum = 0;
				
				bwCikis[basEleman] = dizi[6];
				bwGiris[basEleman] = dizi[7];
				bwOrtalama[basEleman] = dizi[8];
				
				sayac = 0;
				
				try {
					for(int i=basEleman; sayac++ < elemanSayisi && 
					i != (basEleman + maksimumEleman - denemeAraligi)%maksimumEleman; 
					i = (i+maksimumEleman-1)%maksimumEleman)
						if(bwGiris[i] > maksimum)
							maksimum = bwGiris[i];
						else if(bwCikis[i] > maksimum)
							maksimum = bwCikis[i];
						else if(bwOrtalama[i] > maksimum)
							maksimum = bwOrtalama[i];
				} catch (Exception e) {
					maksimum = 2 * bwOrtalama[basEleman];
				}
				maksimum *= 6;
				
				//System.out.println("Bandwith (byte):\t   ic: " + (dizi[6]) + "\t   dis: " + (dizi[7]) + "\t   ort: " + (dizi[8]) + " \t " + maksimum + " ");
			}
			
			snmpIAL 	= 	iletisimArayuzu.getMIBEntry(adresler);

			for (int i = 0; i < snmpIAL.size(); i++) {
				snmpCifti = (SNMPSequence) (snmpIAL.getSNMPObjectAt(i));
				snmpDegeri = snmpCifti.getSNMPObjectAt(1);
				
				dizi[i + 3] = dizi[i];
				dizi[i] = Integer.valueOf( snmpDegeri.toString() );
			}
		} catch (Exception e) {
			System.out.println("ERROR: in calculating bandwith" + e);
		}

		canvas.redraw();
	}

	public static void main(String[] args) {
		String host = "1.1.1.200";
		int port = 23;
		java.net.Socket socket;
		TelnetShow telnet = null;
		TelnetOutputStream tout = null;
		try {
			socket = new java.net.Socket(host, port);
			telnet = new TelnetShow(socket, true);
			tout = telnet.getOutputStream();
		} catch (Exception ex) {
			System.err.println(ex);
		}
		Thread t = new Thread(telnet);
		t.setPriority(Thread.currentThread().getPriority() + 1);
		t.start();
		new MonitorEder(tout).run();
		t.stop();
	}
}
